unit Unit1;


interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, EditBtn, ButtonPanel, Grids, maskedit, uFrameEditCosa, ucosa,
  uCosaConNombre, uActores, uHidroDePasada, uglobs, uHidroConEmbalse,
  uEditFichasLPD;

type

  { TForm1 }

  TControlType = (CCT_TEdit, CCT_TButton, CCT_TCheckBox, CCT_TDateEdit, CCT_TMaskEdit);

  TForm1 = class(TForm)
    Grid: TStringGrid;
    ScrollBox: TScrollBox;

    procedure FormCreate(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; aCol, aRow: Integer; aRect: TRect;
      aState: TGridDrawState);
  private
    Point:TPoint;
    FPrevTopRow: Integer;
    MaxLabelColumWith:integer;
    procedure AddControl(ControlType: TControlType; ACol: integer; ARow: integer; caption: string);
    procedure GridTopLeftChanged(Sender: TObject);
    procedure InsertTCheckBox(xLabelCaption: string);
    procedure InsertTLabelTDateEdit(xLabelCaption: string);
    procedure InsertTLabelTEdit(xLabelCaption: string);
    procedure InsertTLabelTEditTMaskEdit(xLabelCaption: string);
    procedure RearrangeGridButtons;
    //procedure GridButtonClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

type
  TStringGridAccess = class(TStringGrid);

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  DataColumn:TDataColumnOfCosa;
  DataColumnList:TDataColumnListOfCosa;
  i, W, WMax:integer;
begin

  MaxLabelColumWith:=0;

  Grid.Options:=[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,goRangeSelect];

  Grid.OnTopLeftChanged:=GridTopLeftChanged;
  Grid.OnDrawCell:=GridDrawCell;

  DataColumnList:=TGlobs.CreateDataColumnList();

  Grid.RowCount:=DataColumnList.Count+1;
  Grid.ColCount:=2;

  Grid.Cells[0,0]:='Campo';
  Grid.Cells[1,0]:='Valor';

  for i:=0 to DataColumnList.Count-1 do begin
    DataColumn:=DataColumnList.Items[i];
    Grid.Cells[0,i+1]:=DataColumn.ColumnName+':';
  end;

  // ESTO REALMENTE HACE EL AUTOSIZE:
  WMax := 0;
  for i := 0 to (Grid.RowCount - 1) do
  begin
    W := Grid.Canvas.TextWidth(Grid.Cells[0, i]);
    if W > WMax then
      WMax := W;
  end;
  Grid.ColWidths[0] := WMax + 5;

  Grid.ColWidths[1] := 200;

  for i:=0 to DataColumnList.Count-1 do
  begin
    DataColumn:=DataColumnList.Items[i];

    if (DataColumn.DataType is TDataTypeBooleanOfCosa) then
      AddControl(CCT_TCheckBox,1,i+1,DataColumn.ColumnName)

    else if (DataColumn.DataType is TDataTypeCardinalOfCosa) or
            (DataColumn.DataType is TDataTypeDoubleOfCosa)   or
            (DataColumn.DataType is TDataTypeIntegerOfCosa)  or
            (DataColumn.DataType is TDataTypeStringOfCosa)   then
      AddControl(CCT_TEdit,1,i+1,DataColumn.ColumnName)

    else if (DataColumn.DataType is TDataTypeDAOfBooleanOfCosa) or
                (DataColumn.DataType is TDataTypeDAOfDoubleOfCosa)   or
                (DataColumn.DataType is TDataTypeDAOfIntegerOfCosa)  or
                (DataColumn.DataType is TDataTypeDAOfStringOfCosa)   then
          AddControl(CCT_TMaskEdit,1,i+1,DataColumn.ColumnName)

    else if (DataColumn.DataType is TDataTypeDateOfCosa) then
        AddControl(CCT_TDateEdit,1,i+1,DataColumn.ColumnName);

  end;

  Point.x:=10;
  Point.y:=10;

  for i:=0 to DataColumnList.Count-1 do
  begin

    DataColumn:=DataColumnList.Items[i];

    if (DataColumn.DataType is TDataTypeBooleanOfCosa) then
      InsertTCheckBox(DataColumn.ColumnName)

    else if (DataColumn.DataType is TDataTypeCardinalOfCosa) or
            (DataColumn.DataType is TDataTypeDoubleOfCosa)   or
            (DataColumn.DataType is TDataTypeIntegerOfCosa)  or
            (DataColumn.DataType is TDataTypeStringOfCosa)   then
      InsertTLabelTEdit(DataColumn.ColumnName)

    else if (DataColumn.DataType is TDataTypeDAOfBooleanOfCosa) or
            (DataColumn.DataType is TDataTypeDAOfDoubleOfCosa)  or
            (DataColumn.DataType is TDataTypeDAOfIntegerOfCosa) or
            (DataColumn.DataType is TDataTypeDAOfStringOfCosa)  then
      InsertTLabelTEditTMaskEdit(DataColumn.ColumnName)

    else if (DataColumn.DataType is TDataTypeDateOfCosa) then
      InsertTLabelTDateEdit(DataColumn.ColumnName)

  end;

end;

procedure TForm1.InsertTLabelTEdit(xLabelCaption:string);
var
  xLabel:TLabel;
  xEdit:TEdit;
begin
  xLabel:=TLabel.Create(ScrollBox);
  xLabel.Parent:=ScrollBox;
  xLabel.Name:='l_'+xLabelCaption;
  xLabel.Caption:=xLabelCaption+':';
  xLabel.Top:=Point.y;
  xLabel.Left:=Point.x;

  xEdit:=TEdit.Create(ScrollBox);
  xEdit.Parent:=ScrollBox;
  xEdit.Name:='e_'+xLabelCaption;
  xEdit.Caption:='';
  xEdit.Top:=Point.y;
  xEdit.Left:=250;

  Point.y:=Point.y+30;
end;

procedure TForm1.InsertTCheckBox(xLabelCaption:string);
var
  xLabel:TLabel;
  xCheckBox:TCheckBox;
begin
  xLabel:=TLabel.Create(ScrollBox);
  xLabel.Parent:=ScrollBox;
  xLabel.Name:='l_'+xLabelCaption;
  xLabel.Caption:=xLabelCaption+':';
  xLabel.Top:=Point.y;
  xLabel.Left:=Point.x;

  xCheckBox:=TCheckBox.Create(ScrollBox);
  xCheckBox.Parent:=ScrollBox;
  xCheckBox.Name:='cb_'+xLabelCaption;
  xCheckBox.Caption:='';
  xCheckBox.Top:=Point.y;
  xCheckBox.Left:=250;

  Point.y:=Point.y+30;
end;

procedure TForm1.InsertTLabelTEditTMaskEdit(xLabelCaption:string);
var
  xLabel:TLabel;
  xEdit:TEdit;
  xMaskEdit:TMaskEdit;
begin
  xLabel:=TLabel.Create(ScrollBox);
  xLabel.Parent:=ScrollBox;
  xLabel.Name:='l_'+xLabelCaption;
  xLabel.Caption:=xLabelCaption+':';
  xLabel.Top:=Point.y;
  xLabel.Left:=Point.x;

  xEdit:=TEdit.Create(ScrollBox);
  xEdit.Parent:=ScrollBox;
  xEdit.Name:='e_'+xLabelCaption;
  xEdit.Caption:='';
  xEdit.Width:=30;
  xEdit.Top:=Point.y;
  xEdit.Left:=250;

  xMaskEdit:=TMaskEdit.Create(ScrollBox);
  xMaskEdit.Parent:=ScrollBox;
  xMaskEdit.Name:='me_'+xLabelCaption;
  xMaskEdit.Caption:='';
  xMaskEdit.Top:=Point.y;
  xMaskEdit.Left:=290;

  Point.y:=Point.y+30;
end;

procedure TForm1.InsertTLabelTDateEdit(xLabelCaption:string);
var
  xLabel:TLabel;
  xDateEdit:TDateEdit;
begin
  xLabel:=TLabel.Create(ScrollBox);
  xLabel.Parent:=ScrollBox;
  xLabel.Name:='l_'+xLabelCaption;
  xLabel.Caption:=xLabelCaption+':';
  xLabel.Top:=Point.y;
  xLabel.Left:=Point.x;

  xDateEdit:=TDateEdit.Create(ScrollBox);
  xDateEdit.Parent:=ScrollBox;
  xDateEdit.Name:='de_'+xLabelCaption;
  xDateEdit.Caption:='';
  xDateEdit.Top:=Point.y;
  xDateEdit.Left:=250;

  Point.y:=Point.y+30;
end;


procedure TForm1.GridDrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  xGrid:TStringGrid;
begin
  //FORMATO DEL ENCABEZADO
  if ((ACol = 0) and (ARow = 0)) or ((ACol = 1) and (ARow = 0)) then
  begin
    xGrid:=TStringGrid(Sender);
    xGrid.Canvas.Font.Bold:=True;
    xGrid.Canvas.Font.Color:=clWhite;
    xGrid.Canvas.Brush.Color:=clBlack;
    xGrid.Canvas.FillRect(aRect);
    xGrid.Canvas.TextOut(aRect.Left+4,aRect.Top+3,xGrid.Cells[ACol, ARow]);
  end;


end;





procedure TForm1.AddControl(ControlType: TControlType; ACol: integer;
  ARow: integer; caption: string);
var
  R, RA: TRect;
  xPanel:TPanel; xLabel:TLabel; xEdit:TEdit; xMaskEdit: TMaskEdit;
  xControl: TControl;
  width:integer;
begin

  R := Grid.CellRect(ACol, ARow);
  //Inc(R.Right, Grid.GridLineWidth);
  //Dec(R.Left, Grid.GridLineWidth);
  //Inc(R.Bottom, Grid.GridLineWidth);
  Dec(R.Top, Grid.GridLineWidth);

  Case ControlType of
    CCT_TEdit: begin
      xControl := TEdit.Create(Grid);
      xControl.Name:='e_'+caption;
      xControl.Caption := '';
    end;
    CCT_TButton: begin
      xControl := TButton.Create(Grid);
      xControl.Name:='b_'+caption;
    end;
    CCT_TCheckBox:
    begin
      xControl := TCheckBox.Create(Grid);
      xControl.Name:='cb_'+caption;
      xControl.Caption := '';
      Inc(R.Top, 2);
      Inc(R.Left, 5);
    end;
    CCT_TDateEdit:
    begin
      xControl := TDateEdit.Create(Grid);
      xControl.Name:='de_'+caption;
      Dec(R.Right, 23);
    end;
    CCT_TMaskEdit:
    begin
      xPanel:= TPanel.Create(Grid);
      RA:=R;
      Dec(RA.Right, 30);
      xEdit:= TEdit.Create(xPanel);
      //xEdit.BoundsRect:=RA;
      xControl := xPanel;
      xControl.Name:='me_'+caption;
    end;
  end;

  xControl.BoundsRect:=R;

  xControl.Tag := ARow;
  //Edit.OnClick := GridButtonClick;
  xControl.Parent := Grid;
  //Grid.Objects[ACol, ARow] := xEdit;

end;

procedure TForm1.GridTopLeftChanged(Sender: TObject);
begin
  RearrangeGridButtons;
  FPrevTopRow := Grid.TopRow - 1;
end;

procedure TForm1.RearrangeGridButtons;
var
  i: Integer;
  Shift: Integer;
  TopRow, DefaultRowHeight, GridLineWidth, top, a:integer;
  control:TControl;
  name:string;
begin
  TopRow:=Grid.TopRow;
  DefaultRowHeight:=Grid.DefaultRowHeight;
  GridLineWidth:=Grid.GridLineWidth;
  Shift := (Grid.TopRow - FPrevTopRow - 1) * (Grid.DefaultRowHeight);
  for i := 0 to Grid.ControlCount - 1 do
  begin
    Grid.Controls[i].Top := Grid.Controls[i].Top - Shift;
    top:=Grid.Controls[i].Top;
    control:=Grid.Controls[i];
    name:=control.Name;
    if top<0 then
      a:=1;
    Grid.Controls[i].Visible := Grid.Controls[i].Top > 0;
  end;
end;

(*
procedure TForm1.GridButtonClick(Sender: TObject);
var
  Button: TButton absolute Sender;
  N: Integer;
  I: Integer;
begin
  N := GetInsertRowCount(Button.Tag);
  if Button.Caption = '+' then
  begin
    Button.Caption := '-';
    Grid.RowCount := Grid.RowCount + N;
    for I := 1 to N do
      TStringGridAccess(Grid).MoveRow(Grid.RowCount - 1,
        GridButtonToRow(Button) + 1);
    MoveGridButtons(Button.Tag, N);
  end
  else
  begin
    Button.Caption := '+';
    for I := 1 to N do
      TStringGridAccess(Grid).MoveRow(GridButtonToRow(Button) + 1,
        Grid.RowCount - 1);
    Grid.RowCount := Grid.RowCount - N;
    MoveGridButtons(Button.Tag, -N);
  end;
end;
*)
end.

